import { Resolver, ObjectTypeComposer, InterfaceTypeComposer } from 'graphql-compose';
import type { Model, Document } from 'mongoose';
import { FilterHelperArgsOpts, RecordHelperArgsOpts, SortHelperArgsOpts } from './helpers';
import { PayloadRecordIdHelperOpts } from './helpers/payloadRecordId';
export interface UpdateOneResolverOpts {
    suffix?: string;
    record?: RecordHelperArgsOpts;
    filter?: FilterHelperArgsOpts | false;
    sort?: SortHelperArgsOpts | false;
    skip?: false;
    recordId?: PayloadRecordIdHelperOpts | false;
    disableErrorField?: boolean;
}
declare type TArgs = {
    record: any;
    filter?: any;
    skip?: number;
    sort?: string | string[] | Record<string, any>;
};
export declare function updateOne<TSource = any, TContext = any, TDoc extends Document = any>(model: Model<TDoc>, tc: ObjectTypeComposer<TDoc, TContext> | InterfaceTypeComposer<TDoc, TContext>, opts?: UpdateOneResolverOpts): Resolver<TSource, TContext, TArgs, TDoc>;
export {};
//# sourceMappingURL=updateOne.d.ts.map